// (C) 2001-2011 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



import altera_xcvr_functions::*; 

module sv_xcvr_avmm
  #(
    //PARAM_LIST_START
    parameter bonded_lanes        = 1,      // Number of lanes
    parameter bonding_master_ch   = 0,      // Indicates which channel is master
    parameter bonding_master_only = "false",// Indicates bonding_master_channel is MASTER_ONLY
    parameter enable_avmm         = 1       // Enable AVMM adapter - TODO temporary
    //PARAM_LIST_END 
  )  (
    //PORT_LIST_START
    // Reconfiguration signal bundles
    input   wire  [bonded_lanes*W_S5_RECONFIG_BUNDLE_TO_XCVR  -1:0] reconfig_to_xcvr,
    output  wire  [bonded_lanes*W_S5_RECONFIG_BUNDLE_FROM_XCVR-1:0] reconfig_from_xcvr,
    // Calibration clocks
    output  wire  [bonded_lanes-1     :0] calclk, // Calibration clock driven from reconfig clock to aux block
    // Testbus signals
    input   tri0  [bonded_lanes-1     :0] pma_adaptdone,
    input   tri0  [bonded_lanes-1     :0] pma_hardoccaldone,
    output  wire  [bonded_lanes*5-1   :0] pma_eyemonitor,
    output  wire  [bonded_lanes-1     :0] pma_hardoccalen,
    output  wire  [bonded_lanes-1     :0] pma_adcecapture,
    output  wire  [bonded_lanes-1     :0] pma_adcestandby,
    // Channel AVMM interface signals
    output  wire  [bonded_lanes-1     :0] chnl_avmm_clk,
    output  wire  [bonded_lanes-1     :0] chnl_avmm_rstn,
    output  wire  [bonded_lanes*16-1  :0] chnl_avmm_writedata,
    output  wire  [bonded_lanes*11-1  :0] chnl_avmm_address,
    output  wire  [bonded_lanes-1     :0] chnl_avmm_write,
    output  wire  [bonded_lanes-1     :0] chnl_avmm_read,
    output  wire  [bonded_lanes*2-1   :0] chnl_avmm_byteen,
    // PMA AVMM signals
    input   tri0  [bonded_lanes*16-1  :0] pma_avmmreaddata_tx_cgb,  // TX AVMM CGB readdata (16 for each lane)
    input   tri0  [bonded_lanes*16-1  :0] pma_avmmreaddata_tx_ser,  // TX AVMM SER readdata (16 for each lane)
    input   tri0  [bonded_lanes*16-1  :0] pma_avmmreaddata_tx_buf,  // TX AVMM BUF readdata (16 for each lane)
    input   tri0  [bonded_lanes*16-1  :0] pma_avmmreaddata_rx_ser,  // RX AVMM SER readdata (16 for each lane)
    input   tri0  [bonded_lanes*16-1  :0] pma_avmmreaddata_rx_buf,  // RX AVMM BUF readdata (16 for each lane)
    input   tri0  [bonded_lanes*16-1  :0] pma_avmmreaddata_rx_cdr,  // RX AVMM CDR readdata (16 for each lane)
    input   tri0  [bonded_lanes*16-1  :0] pma_avmmreaddata_rx_mux,  // RX AVMM CDR MUX readdata (16 for each lane)
    input   tri0  [bonded_lanes-1     :0] pma_blockselect_tx_cgb,   // TX AVMM CGB blockselect (1 for each lane)
    input   tri0  [bonded_lanes-1     :0] pma_blockselect_tx_ser,   // TX AVMM SER blockselect (1 for each lane)
    input   tri0  [bonded_lanes-1     :0] pma_blockselect_tx_buf,   // TX AVMM BUF blockselect (1 for each lane)
    input   tri0  [bonded_lanes-1     :0] pma_blockselect_rx_ser,   // RX AVMM SER blockselect (1 for each lane)
    input   tri0  [bonded_lanes-1     :0] pma_blockselect_rx_buf,   // RX AVMM BUF blockselect (1 for each lane)
    input   tri0  [bonded_lanes-1     :0] pma_blockselect_rx_cdr,   // RX AVMM CDR readdata (16 for each lane)
    input   tri0  [bonded_lanes-1     :0] pma_blockselect_rx_mux,   // RX AVMM CDR MUX readdata (16 for each lane)
    // PCS AVMM signals
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_com_pcs_pma_if,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_com_pld_pcs_if,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pcs10g_rx,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pcs10g_tx,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pcs8g_rx,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pcs8g_tx,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pcs_g3_rx,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pcs_g3_tx,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pipe12,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_pipe3,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_rx_pcs_pma_if,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_rx_pld_pcs_if,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_tx_pcs_pma_if,
    input   tri0  [bonded_lanes*16-1  :0] avmmreaddata_tx_pld_pcs_if,
    input   tri0  [bonded_lanes-1     :0] blockselect_com_pcs_pma_if,
    input   tri0  [bonded_lanes-1     :0] blockselect_com_pld_pcs_if,
    input   tri0  [bonded_lanes-1     :0] blockselect_pcs10g_rx,
    input   tri0  [bonded_lanes-1     :0] blockselect_pcs10g_tx,
    input   tri0  [bonded_lanes-1     :0] blockselect_pcs8g_rx,
    input   tri0  [bonded_lanes-1     :0] blockselect_pcs8g_tx,
    input   tri0  [bonded_lanes-1     :0] blockselect_pcs_g3_rx,
    input   tri0  [bonded_lanes-1     :0] blockselect_pcs_g3_tx,
    input   tri0  [bonded_lanes-1     :0] blockselect_pipe12,
    input   tri0  [bonded_lanes-1     :0] blockselect_pipe3,
    input   tri0  [bonded_lanes-1     :0] blockselect_rx_pcs_pma_if,
    input   tri0  [bonded_lanes-1     :0] blockselect_rx_pld_pcs_if,
    input   tri0  [bonded_lanes-1     :0] blockselect_tx_pcs_pma_if,
    input   tri0  [bonded_lanes-1     :0] blockselect_tx_pld_pcs_if
    //PORT_LIST_END
  );

localparam  w_bundle_to_xcvr  = W_S5_RECONFIG_BUNDLE_TO_XCVR;
localparam  w_bundle_from_xcvr= W_S5_RECONFIG_BUNDLE_FROM_XCVR;

generate if (enable_avmm == 1) begin
  genvar ig;
  genvar jg;

  wire    [bonded_lanes-1:0]  pld_avmm_clk;
  wire    [bonded_lanes-1:0]  w_interface_sel;
  wire    [bonded_lanes-1:0]  w_ser_shift_load;

  // Use first channel clock for all channels' calclk
  assign  calclk  = {bonded_lanes{pld_avmm_clk[0]}};

  for(ig=0;ig<bonded_lanes;ig=ig+1) begin : avmm_interface_insts
    // Bundle <-> AVMM signals
    // Avalon MM native reconfiguration interfaces
    wire  [15:0]      pld_avmm_writedata; // Avalon DPRIO writedata
    wire  [10:0]      pld_avmm_address;   // Avalon DPRIO address
    wire              pld_avmm_write;     // Avalon DPRIO write
    wire              pld_avmm_read;      // Avalon DPRIO read
    wire  [15:0]      pld_avmm_readdata;  // Avalon DPRIO readdata
    // Testbus
    wire  [23:0]      w_pmatestbus;
    wire  [11:0]      w_pmatestbussel;

    // Bundle <-> xcvr signals
    wire  [14:0]      w_pma_eyemonitor;
    wire  [ 2:0]      w_pma_adcecapture;
    wire  [ 2:0]      w_pma_adcestandby;
    wire  [ 2:0]      w_pma_hardoccalen;

    // Testbus connections
    assign  pma_eyemonitor[ig*5+:5] = w_pma_eyemonitor[0+:5];
    assign  pma_adcecapture[ig]     = w_pma_adcecapture[0];
    assign  pma_adcestandby[ig]     = w_pma_adcestandby[0];
    assign  pma_hardoccalen[ig]     = w_pma_hardoccalen[0];

    // Extract and compose bundled signals
    sv_reconfig_bundle_to_xcvr #(
      .native_ifs         (1)     // number of native reconfig interfaces
    ) sv_reconfig_bundle_to_xcvr_inst(
      // bundled reconfig buses
      .reconfig_to_xcvr         (reconfig_to_xcvr  [ig*w_bundle_to_xcvr  +:w_bundle_to_xcvr  ] ),  // all inputs from reconfig block to native xcvr reconfig ports
      .reconfig_from_xcvr       (reconfig_from_xcvr[ig*w_bundle_from_xcvr+:w_bundle_from_xcvr] ),  // all outputs from native xcvr reconfig ports to reconfig block
      // native reconfig sources
      .native_reconfig_readdata (pld_avmm_readdata          ),  // Avalon DPRIO readdata
      .pif_testbus              (w_pmatestbus               ),
      .pif_testbus_adce_done    ({3{pma_adaptdone     [ig]}}),  // One per channel per triplet
      .pif_hardoccaldone        ({3{pma_hardoccaldone [ig]}}),  // One per channel per triplet

      // native reconfig sinks
      .native_reconfig_clk      (pld_avmm_clk     [ig]  ),
      .native_reconfig_reset    (/*unused*/             ),
      .native_reconfig_writedata(pld_avmm_writedata     ),
      .native_reconfig_address  (pld_avmm_address       ),
      .native_reconfig_write    (pld_avmm_write         ),
      .native_reconfig_read     (pld_avmm_read          ),
      .pif_testbus_sel          (w_pmatestbussel        ), // 4 bits per physical channel
      .pif_testbus_adce_capture (w_pma_adcecapture      ),
      .pif_testbus_adce_standby (w_pma_adcestandby      ),
      .pif_hardoccalen          (w_pma_hardoccalen      ),
      .pif_interface_sel        (w_interface_sel  [ig]  ),
      .pif_ser_shift_load       (w_ser_shift_load [ig]  ),
      .pif_eyemonitor           (w_pma_eyemonitor       )  // Five per channel per triplet

    );

    // Only instantiate avmm block if this is not a bonding master only channel
    if((ig != bonding_master_ch) || (bonding_master_only == "false")) begin
      // DPRIO signals
      wire  [90-1:0]    chnl_avmm_blockselect;
      wire  [15:0]      chnl_avmm_readdata [0:(90-1)];
      wire  [90*16-1:0] chnl_avmm_readdatabus;

      // TX PMA connections
      assign  chnl_avmm_readdata    [ 0] = pma_avmmreaddata_tx_cgb      [ig*16+:16];
      assign  chnl_avmm_blockselect [ 0] = pma_blockselect_tx_cgb       [ig];
      assign  chnl_avmm_readdata    [ 1] = pma_avmmreaddata_tx_ser      [ig*16+:16];
      assign  chnl_avmm_blockselect [ 1] = pma_blockselect_tx_ser       [ig];
      assign  chnl_avmm_readdata    [ 2] = pma_avmmreaddata_tx_buf      [ig*16+:16];
      assign  chnl_avmm_blockselect [ 2] = pma_blockselect_tx_buf       [ig];
      // RX PMA connections
      assign  chnl_avmm_readdata    [ 3] = pma_avmmreaddata_rx_ser      [ig*16+:16];
      assign  chnl_avmm_blockselect [ 3] = pma_blockselect_rx_ser       [ig];
      assign  chnl_avmm_readdata    [ 4] = pma_avmmreaddata_rx_buf      [ig*16+:16];
      assign  chnl_avmm_blockselect [ 4] = pma_blockselect_rx_buf       [ig];
      assign  chnl_avmm_readdata    [ 5] = pma_avmmreaddata_rx_cdr      [ig*16+:16];
      assign  chnl_avmm_blockselect [ 5] = pma_blockselect_rx_cdr       [ig];
      assign  chnl_avmm_readdata    [ 6] = pma_avmmreaddata_rx_mux      [ig*16+:16];
      assign  chnl_avmm_blockselect [ 6] = pma_blockselect_rx_mux       [ig];
      // PCS connections
      assign  chnl_avmm_readdata    [ 7] = avmmreaddata_com_pcs_pma_if  [ig*16+:16];
      assign  chnl_avmm_blockselect [ 7] = blockselect_com_pcs_pma_if   [ig];
      assign  chnl_avmm_readdata    [ 8] = avmmreaddata_com_pld_pcs_if  [ig*16+:16];
      assign  chnl_avmm_blockselect [ 8] = blockselect_com_pld_pcs_if   [ig];
      assign  chnl_avmm_readdata    [ 9] = avmmreaddata_pcs10g_rx       [ig*16+:16];
      assign  chnl_avmm_blockselect [ 9] = blockselect_pcs10g_rx        [ig];
      assign  chnl_avmm_readdata    [10] = avmmreaddata_pcs10g_tx       [ig*16+:16];
      assign  chnl_avmm_blockselect [10] = blockselect_pcs10g_tx        [ig];
      assign  chnl_avmm_readdata    [11] = avmmreaddata_pcs8g_rx        [ig*16+:16];
      assign  chnl_avmm_blockselect [11] = blockselect_pcs8g_rx         [ig];
      assign  chnl_avmm_readdata    [12] = avmmreaddata_pcs8g_tx        [ig*16+:16];
      assign  chnl_avmm_blockselect [12] = blockselect_pcs8g_tx         [ig];
      assign  chnl_avmm_readdata    [13] = avmmreaddata_pcs_g3_rx       [ig*16+:16];
      assign  chnl_avmm_blockselect [13] = blockselect_pcs_g3_rx        [ig];
      assign  chnl_avmm_readdata    [14] = avmmreaddata_pcs_g3_tx       [ig*16+:16];
      assign  chnl_avmm_blockselect [14] = blockselect_pcs_g3_tx        [ig];
      assign  chnl_avmm_readdata    [15] = avmmreaddata_pipe12          [ig*16+:16];
      assign  chnl_avmm_blockselect [15] = blockselect_pipe12           [ig];
      assign  chnl_avmm_readdata    [16] = avmmreaddata_pipe3           [ig*16+:16];
      assign  chnl_avmm_blockselect [16] = blockselect_pipe3            [ig];
      assign  chnl_avmm_readdata    [17] = avmmreaddata_rx_pcs_pma_if   [ig*16+:16];
      assign  chnl_avmm_blockselect [17] = blockselect_rx_pcs_pma_if    [ig];
      assign  chnl_avmm_readdata    [18] = avmmreaddata_rx_pld_pcs_if   [ig*16+:16];
      assign  chnl_avmm_blockselect [18] = blockselect_rx_pld_pcs_if    [ig];
      assign  chnl_avmm_readdata    [19] = avmmreaddata_tx_pcs_pma_if   [ig*16+:16];
      assign  chnl_avmm_blockselect [19] = blockselect_tx_pcs_pma_if    [ig];
      assign  chnl_avmm_readdata    [20] = avmmreaddata_tx_pld_pcs_if   [ig*16+:16];
      assign  chnl_avmm_blockselect [20] = blockselect_tx_pld_pcs_if    [ig];

      // Unused signals
      for(jg=21;jg<90;jg=jg+1) begin : avmm_assigns
        assign  chnl_avmm_blockselect [jg]  = 1'b0;
        assign  chnl_avmm_readdata    [jg]  = 16'd0;
      end

      for(jg=0;jg<90;jg=jg+1) begin : avmm_readdatabus_assigns
        assign  chnl_avmm_readdatabus[jg*16+:16] = chnl_avmm_readdata[jg];
      end

      stratixv_hssi_avmm_interface stratixv_hssi_avmm_interface_inst
      (
        .avmmrstn           (1'b1                             ),
        .avmmclk            (pld_avmm_clk[0]                  ),  // Use first channel clock for all channels
        .avmmwrite          (pld_avmm_write                   ),
        .avmmread           (pld_avmm_read                    ),
        .avmmbyteen         (2'b11                            ),
        .avmmaddress        (pld_avmm_address                 ),
        .avmmwritedata      (pld_avmm_writedata               ),
        .avmmreaddata       (pld_avmm_readdata                ),


        .blockselect        (chnl_avmm_blockselect            ),
        .readdatachnl       (chnl_avmm_readdatabus            ),
        .clkchnl            (chnl_avmm_clk        [ig]        ),
        .rstnchnl           (chnl_avmm_rstn       [ig]        ),
        .writedatachnl      (chnl_avmm_writedata  [ig*16+:16] ),
        .regaddrchnl        (chnl_avmm_address    [ig*11+:11] ),
        .writechnl          (chnl_avmm_write      [ig]        ),
        .readchnl           (chnl_avmm_read       [ig]        ),
        .byteenchnl         (chnl_avmm_byteen     [ig*2+:2]   ),
        
        // The following ports belong to pm_tst_mux blocks in the PMA
        .pmatestbus         (w_pmatestbus                     ),
        .pmatestbussel      (w_pmatestbussel                  ),

        //
        .scanmoden          (1'b1                             ),  // Not used
        .scanshiftn         (1'b1                             ),  // Not used
        .sershiftload       (w_ser_shift_load[0]              ),  // Use first channel signal
        .interfacesel       (w_interface_sel [0]              ),  // Use first channel signal

        .refclkdig          (/*unused*/ ),
        .avmmreservedin     (/*unused*/ ),

        .avmmreservedout    (/*unused*/ ),
        .dpriorstntop       (/*unused*/ ),
        .dprioclktop        (/*unused*/ ),
        .mdiodistopchnl     (/*unused*/ ),
        .dpriorstnmid       (/*unused*/ ),
        .dprioclkmid        (/*unused*/ ),
        .mdiodismidchnl     (/*unused*/ ),
        .dpriorstnbot       (/*unused*/ ),
        .dprioclkbot        (/*unused*/ ),
        .mdiodisbotchnl     (/*unused*/ ),
        .dpriotestsitopchnl (/*unused*/ ),
        .dpriotestsimidchnl (/*unused*/ ),
        .dpriotestsibotchnl (/*unused*/ )
      ); 
    end else begin
      assign  chnl_avmm_clk       [ig]        = 1'b0;
      assign  chnl_avmm_rstn      [ig]        = 1'b1;
      assign  chnl_avmm_writedata [ig*16+:16] = 16'd0;
      assign  chnl_avmm_address   [ig*11+:11] = 11'd0;
      assign  chnl_avmm_write     [ig]        = 1'b0;
      assign  chnl_avmm_read      [ig]        = 1'b0;
      assign  chnl_avmm_byteen    [ig* 2+: 2] = 1'b0;
    end
  end
end else begin
  assign  calclk              = {bonded_lanes{ 1'b0}};
  assign  reconfig_from_xcvr  = {bonded_lanes*w_bundle_from_xcvr{1'b0}};
  assign  pma_adcecapture     = {bonded_lanes{ 1'b0}};
  assign  pma_adcestandby     = {bonded_lanes{ 2'd0}};
  assign  pma_hardoccalen     = {bonded_lanes{ 1'b0}};
  assign  chnl_avmm_clk       = {bonded_lanes{ 1'b0}};
  assign  chnl_avmm_rstn      = {bonded_lanes{ 1'b1}};
  assign  chnl_avmm_writedata = {bonded_lanes{16'd0}};
  assign  chnl_avmm_address   = {bonded_lanes{11'd0}};
  assign  chnl_avmm_write     = {bonded_lanes{ 1'b0}};
  assign  chnl_avmm_read      = {bonded_lanes{ 1'b0}};
  assign  chnl_avmm_byteen    = {bonded_lanes{ 2'd0}};
end
endgenerate

endmodule
